/*
 *  CLRSCR.C - Clear screen
 *
 * Created Mon 6/19/2006 by Jacob Persico
 * Based on the new FreeDOS cls.c
 * All code in this file was created by me Jacob Persico
 *
 * This program is Public Domain.
 * No one party can claim exclusive rights to it.
 *
 */

#include <conio.h>
#include <dos.h>

typedef unsigned char	BYTE;
typedef unsigned short	WORD;
typedef unsigned long	DWORD;

#define TRUE 0x01
#define FALSE 0x00

int main(int argc, BYTE *argv[])
{

 	// Default Lightgray on black (attribute 0x07)
	BYTE *BIOS=MK_FP(0x0040,0x0000);
	BYTE rows=BIOS[0x0084]+1; // rows (EGA/MCGA/VGA)
	BYTE cols=BIOS[0x004A]; // columns
	BYTE pageNo=BIOS[0x0062]; // current video page number
	BYTE temp;
	BYTE y;
	union REGS r;
	BYTE attrib;
	BYTE attribFlag=FALSE;
	BYTE *param=&*argv[1];

	// Skip spaces
	while (*param == 0x20)
	{
		if (*param == 0x00) break;
		param++;
	}
	
	// Set hi 4 bits of attrib
	if (*param > 0x2F && *param < 0x3A)
	{
		attrib=*param<<4;
		attribFlag=TRUE;
	}
	else
	{
		temp=*param & 0xDF;
		if (temp > 0x40 && temp < 0x47)
		{
			attrib=(temp+9)<<4;
			attribFlag=TRUE;
		}
	}

	// Set lo 4 bits of attrib
	if (attribFlag==TRUE)
	{
		attribFlag=FALSE;
		param++;
		if (*param > 0x2F && *param < 0x3A)
		{
			temp=*param & 0x0F;
			attrib=attrib | temp;
			attribFlag=TRUE;
		}
		else
		{
			temp=*param & 0xDF;
			if (temp > 0x40 && temp < 0x47)
			{
				temp=(temp+9) & 0x0F;
				attrib=attrib | temp;
				attribFlag=TRUE;
			}
		}
		param--;
	}

	if (attribFlag==FALSE)
	{
		attrib=0x07;
	}

	// clrscr:
	for (y=0; y<=rows; y++)	// check this
	{
		r.x.ax=0x0920;	// Write space
		r.h.bh=pageNo;
		r.h.bl=attrib;
		r.h.ch=0x00;
		r.h.cl=cols;
		int86(0x10,&r,&r);

		// move caret
		r.h.ah=0x02;
		r.h.bh=pageNo;
		r.h.dh=y;	// Next row
		r.h.dl=0x00;	// Left column
		int86(0x10,&r,&r);
	}
	
	// reset caret (text cursor)
	r.h.ah=0x02;
	r.h.bh=pageNo;
	r.h.dh=0x00;	// Secound row
	r.h.dl=0x00;	// Left column
	int86(0x10,&r,&r);

	return 0;
}
